import static java.lang.Math.*;
public class functorAtomForce extends Thread{
    world olWorld;
    final int start,
        end,
        atomQty;
    final atom atomSrc[],
         atomDest[];

         
    //worldFunc f = new worldFunc();
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorAtomForce(final world _olWorld, final atom [] atomLst, final int _start, final int _end, final int _atomQty)
    {
        olWorld = _olWorld;
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        atomQty = _atomQty;
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
            nuAtom = new atom(atomSrc[i]);
            //interatom forces
            for (int j=0; j<atomQty; j++)
                if (i!=j)
                {
                    vector link = v.sub(nuAtom.pos, atomSrc[j].pos);     // get direction vector
                    double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                    double restlenghtSQ = pow(nuAtom.radius + atomSrc[j].radius,2);     // get collision threshold
                    if (distCentersSQ == 0.0d)                                               // check if position overlap
                        nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                    else if (distCentersSQ < restlenghtSQ)                          // check if collide
                    {
                        nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, atomSrc[j], restlenghtSQ, distCentersSQ, nuAtom.rigidity,0.1));
                        //test fuse, those who dont have type0 and are the same type can fuse
//                        if (atomSrc[j].type != 0)
//                            if (nuAtom.type == atomSrc[j].type)
//                            {   
//                                double nudist = (nuAtom.radius+atomSrc[j].radius) * 1.9;
//                                nuAtom = a.linkWith(nuAtom, j, nudist);
//                            }
                    }
                }

            //spring forces
            for (int j=0; j<nuAtom.linkQty;j++)
            {
                int k = nuAtom.linkedTo[j];
                //link removal ..... to optimize
                if (!a.linkedWith(atomSrc[k], nuAtom.id))
                    nuAtom = a.unLink(nuAtom, j);
                else
                {
                    //link not removal
                    double distCentersSQ = v.distSQ(nuAtom.pos, atomSrc[k].pos);  // returns SQdistance of atoms centers
                    if (distCentersSQ == 0)
                    {
                        //distCentersSQ = 0.1d;                     // case distance = 0, make it work. (could delete spring too or break)
                        nuAtom = a.unLink(nuAtom, j);
                    }
                    else
                    {
                        vector nuforce = a.repulseSQ(nuAtom, atomSrc[k], pow(nuAtom.lenght[j],2), distCentersSQ, nuAtom.rigidity,0.1);
                        nuAtom = a.addforce(nuAtom, nuforce);
                    }
                }
            }

            atomDest[i-start] = nuAtom;
        }
    }
}
