import static java.lang.Math.*;
public class functorWorld extends Thread{
    world olWorld;
    int start,
        end;
    atom atomSrc[],
         atomDest[];
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorWorld(world _olWorld, atom [] atomLst, int _start, int _end)
    {
        olWorld = _olWorld;
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
        
            nuAtom = new atom(atomSrc[i]);
            //hardcollision with the world
            vector delta = v.sub(olWorld.center, nuAtom.pos);
            double refDistSQ = pow(olWorld.radius- nuAtom.radius,2);
            double diffDistSQ = v.magSQ(delta) - refDistSQ;
            if (diffDistSQ > 0)
            {
                nuAtom = a.addforce(nuAtom, a.invRepulseSQ(nuAtom, olWorld.center, pow(olWorld.radius- nuAtom.radius,2), v.magSQ(delta),0.9, 0.1));
            }
            else if (olWorld.gravity > 0)
            {
                //gravity
                //nuAtom = a.addVel(nuAtom, olWorld.gravity);
                //i want 360 gravity
                //note that graivity strengh is proportional to the square of the distance
                //how convenient went magSQ is preferable to mag
                nuAtom = a.addVel(nuAtom, v.scale(delta, diffDistSQ/refDistSQ * olWorld.gravity));
            }
            
            //velocitydrag
            //drag Force = area * velocity^2 * density * coefficient
            //coefficient = 0.47 for a sphere (supposely dimensionless)
            //density = 1.2 for air , 999 for water
            //area = 2 pi r
            //nuAtom = a.subforce(nuAtom, v.scale(v.normalize(nuAtom.vel), v.magSQ(nuAtom.vel) * nuAtom.radius * 0.0062832));
            //nuAtom = a.subforce(nuAtom, v.scale(nuAtom.vel, v.mag(nuAtom.vel) * nuAtom.radius * 0.0062832));//find optimisation
            //great loss of realism, in order to avoid squareroot, i will try to make it proportional and increase drag force
            nuAtom = a.subforce(nuAtom, v.scale(nuAtom.vel, nuAtom.radius * olWorld.airDrag));  //find better
            //  wind
            // same drag force but use arbitrary direction instead of velocity
            //  etc

            atomDest[i-start] = nuAtom;
        }
    }
}
